#include "/usr/rj/dma/tests.h"

unsigned char *to,*fill,*orig,*dmaadr,*mapadr;
unsigned int pval,dump,diff;
unsigned short dmamap,mapto,macto,dma;

main()
{
    printf("\nDMA-test via busskabel: ");fflush(stdout);
    setupdma();
    setupwinch();
    dodma();
    dumpsector();
    cfree(orig);
    dump=kick;
    fflush(stdout);
}

/***************************************************************\
* SETUPDMA initializes the DMA specified by it's argument	*
* for a read of 512 bytes to see if it works.			*
\***************************************************************/
setupdma()
{
    static unsigned char dmatab[] = {
	0xa3,0x83,	/* rst & dis int, disable dma */
        0xc3,0xc3,0xc3,0xc3,0xc3, /* 5 ggr reset */
	0x7a,0x00,0x00,0x00,0x00, /* search port B */
	0xc7,0xcb,		  /* rst A timing,rst B timing */
	0x54,0x0d,		  /* port A mode & timing */
	0x50,0x0d,		  /* port B mode & timing */
	0x80,			  /* DMA disable, no match byte */
	0xdd,0x00,0x00,0x00,	  /* burst mode,B addr,no int. */
	0x92,			  /* ce/wait, stop on EOB, rdy low */
	0xcf,0x8b,		  /* load, reinit status byte */
	0xbb,0x01,0xa7		  /* read mask 01,init rd seq */
    };

    register unsigned int i;
    unsigned int csb;

    printf("\nAllocating memory..."); fflush(stdout);
    orig=to=(unsigned char *) calloc(1024,sizeof(unsigned char));
    while ((unsigned int)to & 0x1ff) to++;
        /* Skip until A0-A8 are low */
    dump=kick;
    macto = (*((unsigned short *)
               (0x80000+((unsigned int)to & 0xff800)))
	      & 0x03ff);
    mapto = macto >> 5;

    diff= 511;
    
    pval=(unsigned int) to;
    dmatab[20]=pval & 255;
    dmatab[21]=pval>>8 & 255;
    
    dmatab[10]=diff & 255;
    dmatab[11]=diff>>8 & 255;

    dmamap=mapto | mapto<<8;

    printf("\nLogical: %x\nPhysical: %x\nDmamap: %x",
           (unsigned int)to,
	   macto << 11,
	   dmamap); fflush(stdout);

    csb = 0xff ^ inb(SASICSB);
    printf("\nSCB-byte: 0x%x",csb); fflush(stdout);
    if (csb == 0x01) {
	    dma=2;
	    dmaadr=BUS2DMA;
	    mapadr=DMA2MAP;
    }
    else if (csb == 0x02) {
	    dma=1;
	    dmaadr=BUS1DMA;
	    mapadr=DMA1MAP;
    }
    else {
	    dma=0;
	    dmaadr=BUS0DMA;
	    mapadr=DMA0MAP;
    }
    printf("\nInitiating dma %d and dmamap %d...",dma,dma);
    fflush(stdout);
    out2b(mapadr,dmamap);
    
    for (i=0;i<29;i++) {
	outb(dmaadr,dmatab[i]);
    }
    spcr=0x06; spcr=0x07; /* reset sysfs & sysscc */
    dump=kick;
}


/***************************************\
* SASIWAIT waits for the wanted status	*
* from the controller using the mask.	*
\***************************************/
sasiwait(mask,value)
register unsigned short mask,value;
{
    while( (inb(SASISTAT) & mask) != value ) ;
}



/***********************************************\
* SETUPWINCH selects the XEBEC-controller	*
* and sends a read-sector command.		*
\***********************************************/
setupwinch()
{
    static unsigned char winchtab[] = {
	0x08,0x00,0x00,0x00,0x01,0x04};
    register unsigned int i;

/*    printf("\nResetting SASI-interface..."); fflush(sdtout);
      outb(SASIRST,0); */

    /* select controller */
    dump=kick;
    sasiwait(4,0);	/* wait for not busy */
    printf("\nSelecting XEBEC-controller..."); fflush(stdout);
    outb(SASIDATA,1);
    outb(SASISEL,0);
    dump=kick;
    sasiwait(4,4); /* wait until controller busy */
    
    /* send read command */
    printf("\nSending Read-command..."); fflush(stdout);
    dump=kick;
    for(i=0;i<6;i++){
	sasiwait(0xf,0xd); /* wait for request of next byte */
	outb(SASIDATA,winchtab[i]);
        printf(" %d",winchtab[i]); fflush(stdout);
	dump=kick;
    };
}


/***********************************************************************\
* DODMA enables the dma-transfer and waits until it's done		*
\***********************************************************************/
dodma()
{
    unsigned int dmastat,statsasi,olddma,oldsasi;

    printf("\nEnabling DMA transfer..."); fflush(stdout);
    outb(dmaadr,0x87); /* enable DMA */
    sasiwait(0x0f,0x07); /* wait for first data byte */
    outb(SASIMODE,0x40); /* enable dma on interface */
    spcr=0x0d;	/* set dmadis-flag */
    dump=kick;

    do {
        olddma = dmastat;
	oldsasi= statsasi;
/*        outb(dmaadr,0xbf); /* read status byte */
	dmastat = inb(dmaadr);
/*        outb(dmaadr,0x87); /* enable DMA */
	statsasi= inb(SASISTAT);
	if (statsasi != oldsasi || dmastat != olddma) {
	    printf("\nDMA: %2x, sasi: %2x",dmastat,statsasi);
	    fflush(stdout);
	}
        dump=kick;
    } while ( (dmastat & 0x20)!=0x00 || (statsasi & 0x0f)!=0x05 );
        /* wait for dma done */

    printf("\nDMA done, XEBEC status: %x\n",inb(SASIDATA) );
    fflush(stdout);
    spcr=0x05;	/* dmadis-flag */
    outb(SASIMODE,0);
    outb(dmaadr,0xc3); /* reset DMA */
}



/*******************************************************\
* DUMPSECTOR displays the data transferred from disk	*
\*******************************************************/
dumpsector()
{
    register unsigned int i;

    pval=(unsigned int) to;
    fill=to;
    for (i=pval;i<=pval+diff;i++) {
	if ((i & 0xf) == 0) printf("\n%3x ",i);
	printf(" %2x",*fill++);
	dump=kick;
    }
    fflush(stdout);
}

    
